-- all credits belong to Swordslayer -> http://www.scriptspot.com/forums/3ds-max/general-scripting/open-all-groups-and-sub-groups

-- i use STRG+G for closing groups and STRG+SHIFT+G for opening groups!


macroScript OPEN_ALL_GROUPS Category:"Custom" toolTip:"open all groups" (
	fn openGroupsAll objs toggle= (
		group_arr = for o in objs where isValidNode o AND isGroupHead o collect o
	 
		with redraw off (
			for o in group_arr do (
				setGroupOpen o toggle
				-- ungroup o
			) -- end for
		)-- end redraw
	) -- end fn

	openGroupsAll objects true
)

macroScript CLOSE_ALL_GROUPS Category:"Custom" toolTip:"close all groups"
(
	fn openGroupsAll objs toggle= (
		group_arr = for o in objs where isValidNode o AND isGroupHead o collect o
	 
		with redraw off (
			for o in group_arr do (
				setGroupOpen o toggle
				-- ungroup o
			) -- end for
		)-- end redraw
	) -- end fn

	openGroupsAll objects false
)


macroScript OPEN_ALL_GROUPS_OF_SELECTION Category:"Custom" toolTip:"open all selected groups" (
	fn openGroupsAll objs toggle= (
		group_arr = for o in objs where isValidNode o AND isGroupHead o collect o
	 
		with redraw off (
			for o in group_arr do (
				setGroupOpen o toggle
				-- ungroup o
			) -- end for
		)-- end redraw
	) -- end fn

	openGroupsAll selection true
)

macroScript CLOSE_ALL_GROUPS_OF_SELECTION Category:"Custom" toolTip:"close all selected groups" (
	fn openGroupsAll objs toggle= (
		group_arr = for o in objs where isValidNode o AND isGroupHead o collect o
	 
		with redraw off (
			for o in group_arr do (
				setGroupOpen o toggle
				-- ungroup o
			) -- end for
		)-- end redraw
	) -- end fn

	openGroupsAll selection false
)
